/*
 * Implementation of class PfcReader
 *
 * $Date: 2003/08/26 10:48:37 $
 * $Revision: 1.2 $
 *
 */

#include "WImage/ImageArray.hh"
#include "WImage/PfcReader.hh"
#include "WImage/debug.h"
#include <pfi.h>
#include <stdio.h>

#ifndef __WATCOMC__
using namespace std;
#endif

int 
PfcReader::readfmt (void)
{
  FILE * fhandle;
  int xsize = 0;
  int ysize = 0;
  int xysize = 0;
  double *values;
  int colors;
  int rgbmodel;
  
  if (m_fname == NULL)
    {
      fhandle = stdin;
    }
  else 
    {
      /*
       * Never fails since checked before.
       */
      fhandle = fopen (m_fname, "rb");
    }

  values = pfi_read (fhandle, &ysize, &xsize, &colors, &rgbmodel);
  
  if (fclose (fhandle) == EOF)
    {
      return -1;
    }

  if (values == NULL)
    {
      return -2;
    }

  if (colors != m_channels)
    {
      return -2;
    }

  switch (rgbmodel)
    {
    case pfi_rgb: 
      m_cmodel = cm_rgb;
      break;
      
    case pfi_yuv:
      m_cmodel = cm_yuv;
      break;

    default:
      return -3;
    }
  
  xysize = xsize * ysize;
  
  for (int i = 0; i < m_channels; i++)
    {
      if (m_images[i]->rows () != ysize || m_images[i]->cols () != xsize)
        {
          m_images[i]->resize (ysize, xsize);
        }
    }
  
  /* import */
  for (int i = 0; i < xysize; i++)
    {
      for (int j = 0; j < m_channels; j++)
        {
          m_images[j]->to (i, (coeff)values[m_channels * i + j]);
        }
    }

  /* cleanup */
  delete [] values;
  
  return 0;
}
