/*
 * Implementation of class PfcWriter
 *
 * $Date: 2003/08/26 10:48:37 $
 * $Revision: 1.2 $
 *
 */

#include "WImage/PfcWriter.hh"
#include "WImage/debug.h"
#include <stdio.h>
#include <pfi.h>

#ifndef __WATCOMC__
using namespace std;
#endif

int
PfcWriter::writefmt (void)
{
  int rc = 0;
  FILE *fhandle;
  
  if (m_fname == NULL)
    {
      fhandle = stdout;
    }
  else 
    {
      /*
       * Never fails since checked before.
       */
      fhandle = fopen (m_fname, "wb");
    }

  int cmodel;
  switch (colormodel ())
    {
    case cm_rgb:
      cmodel = pfi_rgb;
      break;
    case cm_yuv:
      cmodel = pfi_yuv;
      break;
    default:
      return -1;
    }

  int xysize = m_images[0]->size ();
  
  coeff *allcoeffs = new coeff [m_channels * xysize];

  /* import */
  for (int i = 0; i < xysize; i++)
    {
      for (int j = 0; j < m_channels; j++)
        {
          allcoeffs[m_channels * i + j] = m_images[j]->at (i);
        }
    }

  /*
   * And the rest...
   */
  rc = pfi_write (fhandle, allcoeffs, m_images[0]->rows (), 
                  m_images[0]->cols (), m_channels, cmodel, (char*)m_fname);
  
  fclose (fhandle);

  /* cleanup */
  delete [] allcoeffs;
  return rc;
} 
