/*
 * Implementation of class PfgReader
 *
 * $Date: 2003/08/26 10:48:37 $
 * $Revision: 1.2 $
 *
 */

#include "WImage/ImageArray.hh"
#include "WImage/PfgReader.hh"
#include "WImage/debug.h"
#include <pfi.h>
#include <stdio.h>

#ifndef __WATCOMC__
using namespace std;
#endif

int
PfgReader::readfmt (void)
{
  
  FILE * fhandle;
  int xsize = 0, ysize = 0;
  double *values;
  int colors, rgbmodel;
  
  if (m_fname == NULL)
    {
      fhandle = stdin;
    }
  else 
    {
      /*
       * Never fails since checked before.
       */
      fhandle = fopen (m_fname, "rb");
    }

  values = pfi_read (fhandle, &ysize, &xsize, &colors, &rgbmodel);
  
  if (fclose (fhandle) == EOF)
    {
      return -1;
    }

  if (values == NULL)
    {
      return -2;
    }

  if (colors > 1 || rgbmodel != 0)
    {
      return -2;
    }

  m_coeffs->import (ysize, xsize, (coeff*)values);
  
  return 0;
}

