/*
 * Implementation of class PgmWriter
 *
 * $Date: 2003/08/26 10:48:37 $
 * $Revision: 1.3 $
 *
 */

#include "WImage/PgmWriter.hh"
#include "WImage/debug.h"
#include <stdio.h>

int
PgmWriter::writefmt (void)
{
  FILE *fhandle;
  char *writename = (char*)m_fname;
  
  if (m_fname == NULL)
    {
      fhandle = stdout;
      writename = "none (stdout)";
    }
  else 
    {
      /*
       * Never fails since checked before.
       */
      fhandle = fopen (m_fname, "wb");
    }

  /*
   * Write the header...
   */
  if (fprintf (fhandle, "P5\n#%s\n%d %d\n255\n", 
               writename, m_pixels->cols (), m_pixels->rows ()) < 0)
    {
      (void)fclose (fhandle);
      return -1;
    }

  /*
   * And the rest...
   */
  for (int line = 0; line < m_pixels->rows (); line++)
    {
      if (fwrite (&m_pixels->array () [line*m_pixels->cols ()], sizeof (pixel),
                  (size_t)m_pixels->cols (), fhandle) 
          != (size_t)m_pixels->cols ())
        {
          (void)fclose (fhandle);
          return -1;
        }
    }
  
  return (fclose (fhandle) == EOF)? -1: 0;

} 
