/*
 * Implementation of class PpmReader
 *
 * $Date: 2003/08/26 10:48:38 $
 * $Revision: 1.2 $
 *
 */

#include "WImage/ImageArray.hh"
#include "WImage/PpmReader.hh"
#include "WImage/debug.h"
#include "WImage/ppmlib.h"
#include <stdio.h>

#ifndef __WATCOMC__
using namespace std;
#endif

int 
PpmReader::readfmt (void)
{
  FILE *fhandle;
  
  int cmax = 0;
  int xsize = 0; 
  int ysize = 0;
  int xysize = 0;

  if (m_fname == NULL)
    {
      fhandle = stdin;
    }
  else 
    {
      /*
       * Never fails since checked before.
       */
      fhandle = fopen (m_fname, "rb");
    }
  
  /* initialization */
  pixel * allpixels = ppm_fromStream (fhandle, &ysize, &xsize, &cmax);
  fclose (fhandle);
  if (allpixels == NULL)
    {
      return -2;
    }
  xysize = xsize * ysize;
  
  for (int i = 0; i < m_channels; i++)
    {
      if (m_images[i]->rows () != ysize || m_images[i]->cols () != xsize)
        {
          m_images[i]->resize (ysize, xsize);
        }
    }
  
  /* import */
  for (int i = 0; i < xysize; i++)
    {
      for (int j = 0; j < m_channels; j++)
        {
          m_images[j]->to (i, (coeff)allpixels[m_channels * i + j]);
        }
    }

  /* cleanup */
  delete [] allpixels;
  
  return 0;
}
  
