/*
 * Implementation of class RowVector
 *
 * $Date: 2004/05/20 11:06:11 $
 * $Revision: 1.3 $
 *
 */

#include "WImage/debug.h"
#include "WImage/miscdefs.h"
#include "WImage/RowVector.hh"
#include <iostream>
#include <stdexcept>

#ifndef __WATCOMC__
using namespace std;
#endif

void 
RowVector::go (int root)
{
  ImageVector::go (root);
  if (this->m_vroot > this->m_ysize)
    {
      throw invalid_argument ("go: root cannot be greater than rows.");
    }
  this->m_rbase = this->m_vroot * this->m_xsize;
}

coeff 
RowVector::at (int pos) 
{ 
  return m_array->array () [m_rbase + pos];
}

void 
RowVector::to (int pos, coeff val) 
{ 
  m_array->array () [m_rbase + pos] = val;
}

int
RowVector::size (void)
{ 
  return m_array->cols (); 
} 

void 
RowVector::update (void) 
{ 
  ImageVector::update ();
  if (m_vroot > m_ysize)
    {
      m_vroot = m_ysize;
    }
}

