/*
 * Set one pixel in an image
 *
 * $Date: 2003/08/26 10:48:44 $
 * $Revision: 1.2 $
 *
 */

#include <iostream>
#include <stdexcept>
#include <stdio.h>
#include <Wave.hh>

#ifndef __WATCOMC__
using namespace std;
#endif

int
main (int argc, char *argv[])
{
  cout << "pgmpixel version " << WAVE_VERSION << " (c) 2001-2003 by Herbert"
#ifdef PFI
       << " (pfi support enabled)"
#endif
       << endl;

  char *infile;
  char *outfile;
  Image *image = new StillImage ();
  coeff value;
  int xpos, ypos;

  if (argc < 5 || argc > 6)
    {
      cerr << "Usage: pxmpixel <infile> <value> <xpos> <ypos> [<outfile>]\n";
      return 1;
    }

  infile = argv[1];
  if (sscanf (argv[2], "%lf", &value) != 1)
    {
      cerr << "Invalid value: " << argv[2] << endl;
      return 1;
    }
  if (sscanf (argv[3], "%d", &xpos) != 1 || xpos < 0)
    {
      cerr << "Invalid xpos: " << argv[3] << endl;
      return 1;
    }
  if (sscanf (argv[4], "%d", &ypos) != 1 || ypos < 0)
    {
      cerr << "Invalid ypos: " << argv[4] << endl;
      return 1;
    }
  if (argc == 6)
    {
      outfile = argv[5];
    }
  else
    {
      outfile = infile;
    }

  try
    {
      image->read (infile);
    }
  catch (const exception &error)
    {
      cerr << "Reading image: " << error.what () << endl;
      return 1;
    }

  cout << "Replacing value " << image->at (ypos, xpos) << " at (" 
       << xpos << ", " << ypos << ") by " << value << endl;

  image->to (ypos, xpos, value);

  try
    {
      image->write (outfile);
    }
  catch (const exception &error)
    {
      cerr << "Reading image: " << error.what () << endl;
      return 1;
    }

  delete image;
  
  return 0;
}

